select
an.numero,
(select re.nome from sp_setoranimal(an.cdanimal, rep.data) resp join setor re on re.cdsetor = resp.setor) as setor_tentativa,
(select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue,
rep.data,tp.descricao as tipo,
pes.nome as inseminador,
(case when (rep.condicaoia = 'I') then 'Protocolo IAFT' when (rep.condicaoia = 'N') then 'Normal' when (rep.condicaoia = 'P') then 'Prostaglandina' else null end) as condicao_ia,
(case when (rep.condicaoia = 'I') then pro.descricao else null end) as protocolo,
(case when (an.cdcategoriainicial = 7 and an.cdcategoria = 7) then 'Vaca' when (an.cdcategoriainicial <> 7 and an.cdcategoria = 7 and not exists (select * from lactacao lac where dtinicio < rep.data and lac.cdanimal = an.cdanimal)) then 'Novilha'
    when (an.cdcategoria = 6) then 'Novilha' else 'Vaca' end) as categoria_cobertura,
(case when (rep.cdtiporeproducao in (1,2)) then tou.numero when (rep.cdtiporeproducao = 3) then paiemb.numero else null end) as reprodutor,
maeemb.numero as doadora,
 (select grausangue from sp_calculagrausangue(maeemb.cdanimal)) as grau_sangue_doadora,
(case when (prox.diagnostico='P') then 'P' when (prox.cdtiporeproducao in (1,2,3)) then 'N' when (prox.diagnostico='N') then 'N' when (prox.cio in ('1','2')) then 'N'
        when (an.dtbaixa is not null) then 'Baixado'
        else null end) as diagnostico,
(case when (rep.cdmuco = 0) then '0' when (rep.cdmuco = 1) then '1' when (rep.cdmuco = 2) then '2' when (rep.cdmuco = 3) then '3' when (rep.cdmuco = 99) then 'Sem muco' else null end) as muco,
(case when (prox.cdtiporeproducao=4 and prox.diagnostico='P') then prox.dtpartoprovavel else null end) as parto_previsto,
pp.data as parto_real,
tpar.descricao as tipoparto,
(case when (pp.sexocria1 is not null) then pp.sexocria1 else cria.sexo end) as sexo_cria,
(case when (prox.cdtiporeproducao=4 and prox.diagnostico='P' and not exists (select * from reproducao ref4 where ref4.cdanimal=rep.cdanimal and ref4.data>rep.data and (cdtiporeproducao in (1,2,3,7) or (cdtiporeproducao=4 and diagnostico='N') or (cdtiporeproducao=4 and cio in ('1','2'))))) then 'Aberto'
when (prox.cdtiporeproducao=4 and prox.diagnostico='P' and exists (select * from reproducao ref4 where ref4.cdanimal=rep.cdanimal and ref4.data>rep.data and pp.data is null and (cdtiporeproducao in (1,2,3,7) or (cdtiporeproducao=4 and diagnostico='N') or (cdtiporeproducao=4 and cio in ('1','2'))))) then 'Perdeu a gestao'
when (prox.cdtiporeproducao = 4 and prox.diagnostico = 'P' and pp.cdtipoparto = 3) then 'Perdeu a gestao'
else null end) as situacao,
ultpar.data as data_parto_anterior,
(case when ((ultpar.cdreproducao is not null) and (pritenci.cdreproducao is not null))
    then (pritenci.data - ultpar.data) else null end) as interv_ultpar_prim_tent,
(select count(*) from reproducao re where re.cdanimal = rep.cdanimal and re.cdtiporeproducao in (1,2,3) and re.data <= rep.data and
    re.data > coalesce(ultpar.data, '1900-01-01')) as ordem_tentativa
from
animal an join reproducao rep on an.cdanimal=rep.cdanimal
left join reproducao pp on pp.cdreproducao=(select first 1 ref2.cdreproducao from reproducao ref2 where ref2.cdanimal=rep.cdanimal and ref2.data>rep.data and ref2.cdtiporeproducao=7 and not exists (select * from reproducao ref3 where ref3.cdanimal=rep.cdanimal and ref3.data>rep.data and ref3.data<ref2.data and ((ref3.cdtiporeproducao in (1,2,3) or (ref3.cdtiporeproducao=4 and diagnostico='N') or (ref3.cdtiporeproducao=4 and cio not in (1,2))))))
left join tiporeproducao tp on rep.cdtiporeproducao=tp.cdtiporeproducao
left join reproducao prox on prox.cdreproducao=(select first 1 ref.cdreproducao from reproducao ref where rep.cdanimal=ref.cdanimal and ref.data>rep.data and ((ref.cdtiporeproducao=4 and diagnostico is not null) or (ref.cdtiporeproducao=4 and cio in (1,2)) or (ref.cdtiporeproducao in (1,2,3)))order by ref.data)
left join tiporeproducao tp2 on prox.cdtiporeproducao=tp2.cdtiporeproducao
left join animal tou on rep.cdreprodutor=tou.cdanimal
left join animal emb on rep.cdembriao=emb.cdanimal
left join animal maeemb on emb.cdmae=maeemb.cdanimal
left join animal paiemb on emb.cdpai = paiemb.cdanimal
left join tipoparto tpar on pp.cdtipoparto=tpar.cdtipoparto
left join animal cria on cria.cdreproducao=pp.cdreproducao
left join pessoa pes on pes.cdpessoa = rep.cdpessoa
left join protocoloiatf pro on pro.cdprotocoloiatf = rep.cdprotocoloiatf
left join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = rep.cdanimal and re.data < rep.data and re.cdtiporeproducao = 7
        order by re.data desc)
left join reproducao pritenci on pritenci.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ultpar.cdanimal and re.cdtiporeproducao in (1,2,3) and
        re.data > ultpar.data order by re.data asc)
where
rep.cdtiporeproducao in (1,2,3) and
rep.data between '2012-12-01' and '2013-06-14'
order by
an.numero



